#include <bits/stdc++.h>
// Časová složitost: o(n!)

#ifdef GUDEB
    #define D(x) cerr << #x << ": " << (x) << '\n';
    #define ifdeb if(true)
#else
    #define D(x) ;
    #define ifdeb if(false)
#endif

#define all(x) begin(x), end(x)

using namespace std;
using ull = unsigned long long;
using ll = long long;
// #define int ll;

enum TS : char {
    Os = 0,
    R = 1,
};

struct Train {
    int a;
    TS t;
};

int n;
int tt[2];
int nope;

constexpr double TEMP_START = 1000;
constexpr double TEMP_END = 1e-10;
constexpr double TEMP_MUL = 0.99997;

ll sim(vector<Train>& ts) {
    int d = 0;
    int a = 0;
    ll del = 0;
    for(int i = 0; i < n; ++i) {
        d = max(d, ts[i].a);
        a = max(a, d + tt[ts[i].t]);
        del += a - (ts[i].a + tt[ts[i].t]);
    }
    return del;
}

void solve() {
    cin >> n;
    cin >> tt[0] >> tt[1] >> nope;

    vector<Train> ts(n);
    for(int i = 0; i < n; ++i) {
        int t;
        string c;
        cin >> t >> c;
        TS v = Os;
        if(c[0] == 'O') v = Os;
        if(c[0] == 'R') v = R;
        ts[i] = {t, v};
    }


    int del = sim(ts);
    int pdel = 0;
    if(tt[0] == 4) {
        for(int i = n-2; i >= 0; --i) {
            auto[a, t] = ts[i];
            if(t != Os) continue;
            if(ts[i+1].a == a+1 && ts[i+1].t == R) {
                swap(ts[i], ts[i+1]);
                ts[i+1].a += 1;
                int ndel = sim(ts);
                pdel += 1;
                if(ndel+1 < del) {
                    del = ndel;
                } else {
                    pdel -= 1;
                    ts[i+1].a -= 1;
                    swap(ts[i], ts[i+1]);
                }
            }
            if(t == n-2) continue;
            if(ts[i+1].a == a+1 && ts[i+1].t == R
            && ts[i+2].a == a+2 && ts[i+2].t == R) {
                swap(ts[i], ts[i+2]);
                ts[i].a = a+1;
                ts[i+1].a = a+2;
                ts[i+2].a = a+2;
                int ndel = sim(ts);
                pdel += 2;
                if(ndel+2 < del) {
                    del = ndel;
                } else {
                    pdel -= 2;
                    swap(ts[i], ts[i+2]);
                    ts[i].a = a;
                    ts[i+1].a = a+1;
                    ts[i+2].a = a+2;
                }
            }
        }
    }
    cout << del+pdel << '\n';
    return;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}

