#include <bits/stdc++.h>
// Časová složitost: O(n^3)

#ifdef GUDEB
    #define D(x) cerr << #x << ": " << (x) << '\n';
    #define ifdeb if(true)
#else
    #define D(x) ;
    #define ifdeb if(false)
#endif

#define all(x) begin(x), end(x)

using namespace std;
using ull = unsigned long long;
using ll = long long;
// #define int ll;

enum TS : char {
    Os = 0,
    R = 1,
};

struct Train {
    int a;
    TS t;
};

int n;
ll dp[1001];

void solve() {
    cin >> n;
    vector<Train> ts(n);
    int tt[2];
    int nope;
    cin >> tt[0] >> tt[1] >> nope;

    vector<int> times;
    times.reserve(n+1);
    times.push_back(-tt[0]);

    for(int i = 0; i < n; ++i) {
        int a;
        string c;
        cin >> a >> c;
        TS t = Os;
        if(c[0] == 'O') t = Os;
        if(c[0] == 'R') t = R;
        ts[i] = {a, t};
        times.push_back(a);
    }

    int osc[1001];
    osc[0] = 0;

    for(int i = 0; i < n; ++i) {
        osc[i+1] = osc[i] + (ts[i].t == Os);
    }

    int lastr = -tt[R];
    for(int i = 1; i <= n; ++i) {
        auto [start, tp] = ts[i-1];

        // add the train
        if(tp == R) {
            for(int o = 0; o < i; ++o) {
                int end = max({times[o] + tt[Os], lastr + tt[R ]});
                int del = max(0, end - (start + tt[R]));
                dp[o] += del;
            }
            lastr = start;
        }

        dp[i] = 1e18;

        // release the osobáks!
        for(int o = 0; o < i; ++o) {
            int end = max(times[o] + tt[Os], lastr + tt[R]);
            int del = (osc[i] - osc[o])*max(0, end - (start + tt[Os]));
            dp[i] = min(dp[i], dp[o] + del);
        }

        // add delays!
        if(i != n) {
            int new_st = ts[i].a;
            int delta = new_st - start;
            for(int o = 0; o <= i; ++o) {
                dp[o] += 1ll*(osc[i] - osc[o])*delta;
            }
        }
    }

    cout << dp[n] << '\n';
    return;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}

