#include <bits/stdc++.h>
// Časová složitost: o(n!)

#ifdef GUDEB
    #define D(x) cerr << #x << ": " << (x) << '\n';
    #define ifdeb if(true)
#else
    #define D(x) ;
    #define ifdeb if(false)
#endif

#define all(x) begin(x), end(x)

using namespace std;
using ull = unsigned long long;
using ll = long long;
// #define int ll;

enum TS : char {
    Os = 0,
    R = 1,
    Ex = 2,
};

struct Train {
    int a;
    TS t;
};

int n;
int tt[3];

ll sim(vector<Train>& ts) {
    int d = 0;
    int a = 0;
    ll del = 0;
    for(int i = 0; i < n; ++i) {
        d = max(d, ts[i].a);
        a = max(a, d + tt[ts[i].t]);
        del += a - (ts[i].a + tt[ts[i].t]);
    }
    return del;
}

void solve() {
    cin >> n;
    cin >> tt[0] >> tt[1] >> tt[2];

    vector<Train> ts(n);
    for(int i = 0; i < n; ++i) {
        int t;
        string c;
        cin >> t >> c;
        TS v = Os;
        if(c[0] == 'O') v = Os;
        if(c[0] == 'R') v = R;
        if(c[0] == 'E') v = Ex;
        ts[i] = {t, v};
    }


    cout << sim(ts) << '\n';
    return;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}

