#include <bits/stdc++.h>
// Časová složitost: o(n!)

#ifdef GUDEB
    #define D(x) cerr << #x << ": " << (x) << '\n';
    #define ifdeb if(true)
#else
    #define D(x) ;
    #define ifdeb if(false)
#endif

#define all(x) begin(x), end(x)

using namespace std;
using ull = unsigned long long;
using ll = long long;
// #define int ll;

enum TS : char {
    Os = 0,
    R = 1,
    Ex = 2,
};

struct Train {
    int a;
    TS t;
};

Train ts[1000];
int n;
int tt[3];
ll best = 1e18;

void bf(ull bm, int d, int a, ll del) {
    if(del > best) return;
    if(bm == (1ull << n) - 1ull) {
        best = del;
        return;
    }
    for(int i = 0; i < n; ++i) {
        if(bm & (1ull << i)) continue;
        int nd = max(d, ts[i].a);
        int na = max(a, nd + tt[ts[i].t]);
        ll ddel = na - (ts[i].a + tt[ts[i].t]);
        bf(bm | (1ull << i), nd, na, del + ddel);
    }
}

void solve() {
    cin >> n;
    cin >> tt[0] >> tt[1] >> tt[2];

    for(int i = 0; i < n; ++i) {
        int t;
        string c;
        cin >> t >> c;
        TS v = Os;
        if(c[0] == 'O') v = Os;
        if(c[0] == 'R') v = R;
        if(c[0] == 'E') v = Ex;
        ts[i] = {t, v};
    }

    if(n > 64) {
        return;
    }

    bf(0ull, 0, 0, 0);
    cout << best << '\n';
    return;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}

