#include <bits/stdc++.h>
// Časová složitost: o(n!)

#ifdef GUDEB
    #define D(x) cerr << #x << ": " << (x) << '\n';
    #define ifdeb if(true)
#else
    #define D(x) ;
    #define ifdeb if(false)
#endif

#define all(x) begin(x), end(x)

using namespace std;
using ull = unsigned long long;
using ll = long long;
// #define int ll;

enum TS : char {
    Os = 0,
    R = 1,
    Ex = 2,
};

struct Train {
    int a;
    TS t;
};

Train ts[1000];
int n;
int tt[3];
ll best = 1e18;

ll dp[1001];

void bf(ull bm, int d, int a, ll del) {
    if(del > best) return;
    if(bm == (1ull << n) - 1ull) {
        best = del;
        return;
    }
    for(int i = 0; i < n; ++i) {
        if(bm & (1ull << i)) continue;
        int nd = max(d, ts[i].a);
        int na = max(a, nd + tt[ts[i].t]);
        ll ddel = na - (ts[i].a + tt[ts[i].t]);
        bf(bm | (1ull << i), nd, na, del + ddel);
    }
}

void solve() {
    cin >> n;
    cin >> tt[0] >> tt[1] >> tt[2];

    vector<int> times;
    times.reserve(n+1);
    times.push_back(-tt[0]);

    for(int i = 0; i < n; ++i) {
        int t;
        string c;
        cin >> t >> c;
        TS v = Os;
        if(c[0] == 'O') v = Os;
        if(c[0] == 'R') v = R;
        if(c[0] == 'E') v = Ex;
        ts[i] = {t, v};
        times.push_back(t);
    }

    if(n <= 40) {
        bf(0ull, 0, 0, 0);
        cout << best << '\n';
        return;
    }

    int osc[1001];
    osc[0] = 0;

    for(int i = 0; i < n; ++i) {
        osc[i+1] = osc[i] + (ts[i].t == Os);
    }

    int lastr = -tt[R];
    for(int i = 1; i <= n; ++i) {
        auto [start, tp] = ts[i-1];

        // add the train
        if(tp == R) {
            for(int o = 0; o < i; ++o) {
                int end = max({times[o] + tt[Os], lastr + tt[R ]});
                int del = max(0, end - (start + tt[R]));
                dp[o] += del;
            }
            lastr = start;
        }

        dp[i] = 1e18;

        // release the osobáks!
        for(int o = 0; o < i; ++o) {
            int end = max(times[o] + tt[Os], lastr + tt[R]);
            int del = (osc[i] - osc[o])*max(0, end - (start + tt[Os]));
            dp[i] = min(dp[i], dp[o] + del);
        }

        // add delays!
        if(i != n) {
            int new_st = ts[i].a;
            int delta = new_st - start;
            for(int o = 0; o <= i; ++o) {
                dp[o] += 1ll*(osc[i] - osc[o])*delta;
            }
        }
    }

    cout << dp[n] << '\n';
    return;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}

